

#ifndef _QDEF_H_
#define _QDEF_H_
#include "config.h"
#ifdef __cplusplus
extern "C"
{
#endif

#define QCAM_MAXCAMERACOUNT 16

#define QCAM_IOTYPE_USB 10
#define QCAM_IOTYPE_ETHERNET 20

#define QCAM_CAMTYPE_UNKNOWN -1

  //QHYCCD A series and QHY27/28/29
#define QCAM_CAMTYPE_QHY16200A 200
#define QCAM_CAMTYPE_IC8300    201
#define QCAM_CAMTYPE_QHY90A    202
#define QCAM_CAMTYPE_QHY29     203
#define QCAM_CAMTYPE_QHY28     204
#define QCAM_CAMTYPE_QHY814A   205
#define QCAM_CAMTYPE_QHY16803A 206
#define QCAM_CAMTYPE_QHY27     207
#define QCAM_CAMTYPE_QHY09000A 208
#define QCAM_CAMTYPE_QHY695A   299

#define QCAM_CAMTYPE_QHY5II 350
#define QCAM_CAMTYPE_QHY5TII 351
#define QCAM_CAMTYPE_QHY5VII 352
#define QCAM_CAMTYPE_QHY5UII 353
#define QCAM_CAMTYPE_QHY5PII_M 354
#define QCAM_CAMTYPE_QHY5LII_M 355
#define QCAM_CAMTYPE_QHY5XII 356
#define QCAM_CAMTYPE_QHY5FII 357
#define QCAM_CAMTYPE_QHY5HII 358
#define QCAM_CAMTYPE_MINICAM5S_M 359
#define QCAM_CAMTYPE_MINICAM5S_C 360
#define QCAM_CAMTYPE_QHY16000 361
#define QCAM_CAMTYPE_MINICAM5F_M 362
#define QCAM_CAMTYPE_MINICAM5F_C 363
#define QCAM_CAMTYPE_QHY5    364
#define QCAM_CAMTYPE_QHY5LII_C 365
#define QCAM_CAMTYPE_QHY5PII_C 366
#define QCAM_CAMTYPE_QHY5RII 400
#define QCAM_CAMTYPE_PLUTO285 520
#define QCAM_CAMTYPE_URANUS285 620
#define QCAM_CAMTYPE_URANUS694 660
#define QCAM_CAMTYPE_URANUS814 690



#define QCAM_CAMTYPE_QHY8L    891
#define QCAM_CAMTYPE_QHY9S    892
#define QCAM_CAMTYPE_QHY10    893
#define QCAM_CAMTYPE_QHY11    894
#define QCAM_CAMTYPE_QHY21    895
#define QCAM_CAMTYPE_QHY22    896
#define QCAM_CAMTYPE_QHY23    897
#define QCAM_CAMTYPE_TITAN174U 900
#define QCAM_CAMTYPE_TITAN178U 910
#define QCAM_CAMTYPE_TITAN224U 920
#define QCAM_CAMTYPE_TITAN226U 930
#define QCAM_CAMTYPE_TITAN185U 931
#define QCAM_CAMTYPE_TITAN236U 932
#define QCAM_CAMTYPE_TITANG400U 933
#define QCAM_CAMTYPE_TITAN290U 934
#define QCAM_CAMTYPE_TITAN163U 935
#define QCAM_CAMTYPE_TITAN165U 936
#define QCAM_CAMTYPE_TITAN367U 937
#define QCAM_CAMTYPE_TITAN183U 938
#define QCAM_CAMTYPE_QHY5III   999

  //#define QCAM_CAMTYPE_QHY5LII_M    53
  //#define QCAM_CAMTYPE_QHY5LII_C    531

#define QCAM_MODE_FOCUS 10
#define QCAM_MODE_PREVIEW 20
#define QCAM_MODE_FULL 30

#define QCAM_DEPTH_BIT8 10
#define QCAM_DEPTH_BIT16 20

#define QCAM_TRANSFERSPEED_HIGH 10
#define QCAM_TRANSFERSPEED_MEDIUM 20
#define QCAM_TRANSFERSPEED_LOW 30

#define QCAM_SCENE_AUTO 10
#define QCAM_SCENE_MICROSCOPE 20
#define QCAM_SCENE_FLUORESCENCE 30

#define QCAM_AWBMODE_GLOBAL 10
#define QCAM_AWBMODE_SPOT 20

#define QCAM_DEMOSAICMODE_NONE 0
#define QCAM_DEMOSAICMODE_RGGB 1
#define QCAM_DEMOSAICMODE_GRBG 2
#define QCAM_DEMOSAICMODE_BGGR 3
#define QCAM_DEMOSAICMODE_GBRG 4

#ifdef __cplusplus

}
#endif

#endif
