

/*!
 * @file ic8300.h
 * @brief IC8300 class define
 */

#include "qhyabase.h"
#include "config.h"
#ifndef __IC8300DEF_H__
#define __IC8300DEF_H__

/**
 * @brief IC8300 class define
 *
 * include all functions for ic8300
 */
class IC8300:public QHYABASE
{
public:
  IC8300();
  ~IC8300();

  /**
      @fn uint32_t SetChipBinMode(qhyccd_handle *h,uint32_t wbin,uint32_t hbin)
      @brief set the camera offset
      @param h camera control handle
      @param wbin width bin
      @param hbin height bin
      @return
      success return QHYCCD_SUCCESS \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t SetChipBinMode(qhyccd_handle *h,uint32_t wbin,uint32_t hbin);

  /**
   @fn uint32_t SendOrder2CFW(qhyccd_handle *handle,char *order,uint32_t length)
   @brief send the command to camera's color filter wheel port
   @param handle camera control handle
   @param order the color filter position
  @param length  the order string length
   @return
   success return QHYCCD_SUCCESS \n
   another QHYCCD_ERROR code on other failures
   */
  uint32_t SendOrder2CFW(qhyccd_handle *handle,char *order,uint32_t length);


  uint32_t SetFocusSetting(qhyccd_handle *h, uint32_t focusCenterX, uint32_t focusCenterY);

};
#endif

