

#include "minicam5base.h"
#include "config.h"
#ifndef MINICAM5F_M_DEF
#define MINICAM5F_M_DEF


/**
 * @brief MINICAM5S_M class define
 *
 * include all functions for miniCam5s-m
 */
class MINICAM5F_M:public MINICAM5BASE
{
public:
  MINICAM5F_M();
  ~MINICAM5F_M();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
   @fn uint32_t GetControlMinMaxStepValue(CONTROL_ID controlId,double *min,double *max,double *step)
   @brief get the min,max and step value for function
   @param controlId the control id
   @param min the min value for function
   @param max the max value for function
   @param step single step value for function
   @return
   success return QHYCCD_SUCCESS \n
   another QHYCCD_ERROR code on other failures
   */
  uint32_t GetControlMinMaxStepValue(CONTROL_ID controlId,double *min,double *max,double *step);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();

  uint32_t IsCFWPlugged(qhyccd_handle *handle);

private:
};
#endif
