

#include "qhy5iii178coolbase.h"
#include "config.h"
#ifndef MINICAM6F_DEF
#define MINICAM6F_DEF


/**
 * @brief MINICAM6F class define
 *
 * include all functions for MINICAM6F
 */
class MINICAM6F:public QHY5III178COOLBASE
{
public:
  MINICAM6F();
  ~MINICAM6F();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();
};
#endif
