
#include "qhy5iii128base.h"
#include "config.h"
#ifndef QHY128_C_DEF
#define QHY128_C_DEF


/**
 * @brief QHY128C class define
 *
 * include all functions for qhy128c
 */
class QHY128C:public QHY5III128BASE
{
public:
  QHY128C();
  ~QHY128C();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();
};
#endif
