

#include "qhy5iii163base.h"
#include "config.h"
#ifndef QHY163_M_DEF
#define QHY163_M_DEF


/**
 * @brief QHY163M class define
 *
 * include all functions for qhy163m
 */
class QHY163M:public QHY5III163BASE
{
public:
  QHY163M();
  virtual ~QHY163M();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();
};
#endif
