
#include "qhy5iii174base.h"
#include "config.h"
#ifndef QHY174_C_DEF
#define QHY174_C_DEF


/**
 * @brief QHY224C class define
 *
 * include all functions for qhy174c
 */
class QHY174C:public QHY5III174BASE
{
public:
  QHY174C();
  ~QHY174C();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();
};
#endif
