

#include "qhy5iii178coolbase.h"
#include "config.h"
#ifndef QHY178_C_DEF
#define QHY178_C_DEF


/**
 * @brief QHY178C class define
 *
 * include all functions for qhy178c
 */
class QHY178C:public QHY5III178COOLBASE
{
public:
  QHY178C();
  ~QHY178C();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();
};
#endif
