
#include "qhy5iii178coolbase.h"
#include "config.h"
#ifndef QHY178_M_DEF
#define QHY178_M_DEF


/**
 * @brief QHY178M class define
 *
 * include all functions for qhy178m
 */
class QHY178M:public QHY5III178COOLBASE
{
public:
  QHY178M();
  ~QHY178M();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();
};
#endif
