
#include "qhy5iii183base.h"
#include "config.h"
#ifndef QHY183_C_DEF
#define QHY183_C_DEF


/**
 * @brief QHY183C class define
 *
 * include all functions for qhy183c
 */
class QHY183C:public QHY5III183BASE
{
public:
  QHY183C();
  ~QHY183C();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();
};
#endif
