

#include "qhy5iii224coolbase.h"
#include "config.h"
#ifndef QHY224_C_DEF
#define QHY224_C_DEF


/**
 * @brief QHY224C class define
 *
 * include all functions for qhy224c
 */
class QHY224C:public QHY5III224COOLBASE
{
public:
  QHY224C();
  ~QHY224C();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();
};
#endif
