
#include "qhy5iii290coolbase.h"
#include "config.h"
#ifndef QHY290_M_DEF
#define QHY290_M_DEF


/**
 * @brief QHY290M class define
 *
 * include all functions for qhy290m
 */
class QHY290M:public QHY5III290COOLBASE
{
public:
  QHY290M();
  ~QHY290M();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();
};
#endif
