

#include "qhy5iii185base.h"
#include "config.h"
#ifndef QHY5III185_C_DEF
#define QHY5III185_C_DEF


/**
 * @brief QHY5III185C class define
 *
 * include all functions for qhy5iii185c
 */
class QHY5III185C:public QHY5III185BASE
{
public:
  QHY5III185C();
  ~QHY5III185C();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();
};
#endif
