

#include "qhy5iii224base.h"
#include "config.h"
#ifndef QHY5III224_C_DEF
#define QHY5III224_C_DEF


/**
 * @brief QHY5III224C class define
 *
 * include all functions for qhy5iii174m
 */
class QHY5III224C:public QHY5III224BASE
{
public:
  QHY5III224C();
  ~QHY5III224C();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();

};
#endif
