
#include "config.h"
#include "qhycam.h"
#include "qhyccdcamdef.h"
#include "qhyccderr.h"
#include "cmosdll.h"
#include "stdint.h"
#include "qhy5iiibase.h"


#ifndef __QHY5IIICOOLBASEDEF_H__
#define __QHY5IIICOOLBASEDEF_H__

/**
 * the QHY5IIICOOLBASE class description
 */
class QHY5IIICOOLBASE:public QHY5IIIBASE
{

public:
  uint8_t firstcheckfilters;



public:
  QHY5IIICOOLBASE()
  {
    firstcheckfilters = 1;
    flagtempauto = false;	
  }

  virtual ~QHY5IIICOOLBASE()
  {}
  ;

  double GetChipCoolTemp(qhyccd_handle *pDevHandle);
  double GetChipCoolPWM();

  uint32_t AutoTempControl(qhyccd_handle *pDevHandle,double ttemp);
  uint32_t SetChipCoolPWM(qhyccd_handle *pDevHandle,double PWM);
  uint32_t SendOrder2CFW(qhyccd_handle *pDevHandle,char *order,uint32_t length);
  uint32_t GetCFWStatus(qhyccd_handle *pDevHandle,char *status);
  uint32_t IsCFWPlugged(qhyccd_handle *pDevHandle);
  uint32_t GetCFWSlotsNum(qhyccd_handle *pDevHandle);
  uint32_t CancelExposing(qhyccd_handle *pDevHandle);
  uint32_t CancelExposingAndReadout(qhyccd_handle *pDevHandle);

private:  
  double  lastPWM;
  
};

#endif
