

#include "qhy5liibase.h"
#include "config.h"
#ifndef QHY5LII_C_DEF
#define QHY5LII_C_DEF

/**
 * @brief QHY5LII_C class define
 *
 * include all functions for qhy5lii-c
 */
class QHY5LII_C:public QHY5LIIBASE
{
public:
  QHY5LII_C();
  virtual ~QHY5LII_C();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();



  uint32_t SetChipGain(qhyccd_handle *h,double gain);
  uint32_t GetControlMinMaxStepValue(CONTROL_ID controlId, double *min, double *max, double *step);

private:
};
#endif
