

#include "qhy5liibase.h"
#include "config.h"
#ifndef QHY5LII_M_DEF
#define QHY5LII_M_DEF

/**
 * @brief QHY5LII_M class define
 *
 * include all functions for qhy5lii-m
 */
class QHY5LII_M:public QHY5LIIBASE
{
public:
  QHY5LII_M();
  virtual ~QHY5LII_M();

  /**
   @fn uint32_t IsChipHasFunction(CONTROL_ID id)
   @brief check the camera has the function or not
   @param id function id
   @return
   HAVE return QHYCCD_HAVE \n
   NOT HAVE return QHYCCD_NOTHAVE
   */
  uint32_t IsChipHasFunction(CONTROL_ID id);

  /**
      @fn virtual uint32_t GetChipMemoryLength()
      @brief get the image cost memory length
      @return
      success return memory length \n
      another QHYCCD_ERROR code on other failures
      */
  uint32_t GetChipMemoryLength();

};
#endif
