

#include "qhyabase.h"
#include "config.h"
#ifndef __QHY695ADEF_H__
#define __QHY695ADEF_H__

/**
 * @brief QHY695A class define
 *
 * include all functions for QHY695A
 */
class QHY695A:public QHYABASE
{
public:
  QHY695A();
  ~QHY695A();

  /**
   @fn uint32_t SetChipBinMode(qhyccd_handle *h,uint32_t wbin,uint32_t hbin)
   @brief set the camera offset
   @param h camera control handle
   @param wbin width bin
   @param hbin height bin
   @return
   success return QHYCCD_SUCCESS \n
   another QHYCCD_ERROR code on other failures
   */
  uint32_t SetChipBinMode(qhyccd_handle *h,uint32_t wbin,uint32_t hbin);

  /**
    @fn uint32_t SetFocusSetting(qhyccd_handle *h,uint32_t focusCenterX, uint32_t focusCenterY)
    @brief Set the camera on focus mode
    @param h camera control handle
    @param focusCenterX
    @param focusCenterY
    @return
  on success,return QHYCCD_SUCCESS \n
  another QHYCCD_ERROR code on other failures
   */
  uint32_t SetFocusSetting(qhyccd_handle *h,uint32_t focusCenterX, uint32_t focusCenterY);

  double GetChipCoolPWM();

  uint32_t AutoTempControl(qhyccd_handle *h,double ttemp);

  uint32_t SetChipCoolPWM(qhyccd_handle *h,double PWM);

  double GetChipCoolTemp(qhyccd_handle *h);

  /**
    @fn uint32_t SetChipResolution(qhyccd_handle *handle,uint32_t x,uint32_t y,uint32_t xsize,uint32_t ysize)
    @brief set camera ouput resolution
    @param handle camera control handle
    @param x the top left position x
    @param y the top left position y
    @param xsize the image width
    @param ysize the image height
    @return
    on success,return QHYCCD_SUCCESS\n
    another QHYCCD_ERROR code on other failures
    */
  uint32_t SetChipResolution(qhyccd_handle *handle,uint32_t x,uint32_t y,uint32_t xsize,uint32_t ysize);

private:
  double lastTargetTemp;
  double  lastPWM;

};
#endif

