#include "qhyabase.h"
#include "config.h"
#ifndef __QHY814ADEF_H__
#define __QHY814ADEF_H__
class QHY814A:public QHYABASE
{
public:
  QHY814A();
  ~QHY814A();

  /**
   @fn uint32_t SetChipBinMode(qhyccd_handle *h,uint32_t wbin,uint32_t hbin)
   @brief set the camera offset
   @param h camera control handle
   @param wbin width bin
   @param hbin height bin
   @return
   success return QHYCCD_SUCCESS \n
   another QHYCCD_ERROR code on other failures
   */
  uint32_t SetChipBinMode(qhyccd_handle *h,uint32_t wbin,uint32_t hbin);


  uint32_t SetFocusSetting(qhyccd_handle *h, uint32_t focusCenterX, uint32_t focusCenterY);

  double GetChipCoolPWM();

  uint32_t AutoTempControl(qhyccd_handle *h,double ttemp);

  uint32_t SetChipCoolPWM(qhyccd_handle *h,double PWM);

  double GetChipCoolTemp(qhyccd_handle *h);

private:
  double lastTargetTemp;
  double  lastPWM;
};
#endif

