

#include "config.h"
#ifndef __SSD1306_H__
#define __SSD1306_H__

#include "i2c.h"
#include <stdint.h>


typedef struct
{
  i2c_dev_t *i2c_dev;
  uint8_t *buf;
  int16_t width;
  int16_t height;
}
ssd1306_t;


/* initializes display */
void ssd1306_init(ssd1306_t *ssd, i2c_dev_t *i2c_dev);

/* inverts display */
void ssd1306_invert(ssd1306_t *ssd, uint8_t inv);

/* writes buffer contents to display */
void ssd1306_update(ssd1306_t *ssd);

/* clears buffer */
void ssd1306_clear(ssd1306_t *ssd);

/* sets pixel in buffer */
void ssd1306_set_pixel(ssd1306_t *ssd, int16_t x, int16_t y, uint16_t color);


#endif /* __SSD1306_H__ */

